#!c:/perl/bin/perl.exe
use warnings;
use strict;
use diagnostics;
use Statistics::ChiSquare;
use Net::Random;

my $rand = Net::Random -> new(
	src => 'random.org',
	min => 0,
	max => 6,
	);

foreach my $number_rolls (10,100,1000,10000) {

	my @array = roll_dice($number_rolls);
	print "For $number_rolls rolls using rand: ",chisquare(@array),"\n";
	
	my @net_array = roll_net_dice($number_rolls);
	print "For $number_rolls using random.org: ",chisquare(@net_array),"\n\n";
	
}

sub roll_dice {

	my ($count) = @_;

	# Initialise the array with zeros in case
	# we never roll a particular number (which
	# would give us undef as it's count)
	my @array = (0,0,0,0,0,0);
	
	# Although a dice is 1-6 it's easier to 
	# randomly generate 0-5 and as this maps
	# nicely to the array index we'll do that.
	for (1..$count) {
		++$array[int(rand(6))];	
	}
				
	return @array;
}

sub roll_net_dice {

	my ($count) = @_;

	my @numbers = $rand -> get($count);

	# Initialise the array with zeros in case
	# we never roll a particular number (which
	# would give us undef as it's count)
	my @array = (0,0,0,0,0,0);
	
	foreach (@numbers) {
		++$array[int(rand(6))];	
	}
			
	return @array;
}
